<?php
/*  
Copyright:  2010 Haden Software <http://haden.cc/>

Released under the terms of the GNU General Public License.
You should have received a copy of the GNU General Public License,
along with this software. In the main directory, see: /licensing/
If not, see: <http://www.gnu.org/licenses/>.
*/

/**************************************************************************************************/
/* Direct access denial.                                                                          */
/**************************************************************************************** 0.9.0 ***/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
  exit ("Do not access this file directly.");

/**************************************************************************************************/
/* Function to display admin notices on the Super Admin >> Options page                           */
/*  add_action("admin_init",...);                                                                 */
/**************************************************************************************** 0.9.0 ***/
if (!function_exists ("hsmember_notices_super_admin_options")) {
  function hsmember_notices_super_admin_options() {
    do_action ("hsmember_notices_before_super_admin_options", get_defined_vars ());
    if ($GLOBALS["_HSMEMBER_"]["o"]["blog_create_access"] &&
        $GLOBALS["_HSMEMBER_"]["o"]["blog_create_access"] > 0 &&
				version_compare(WS_PLUGIN__S2MEMBER_VERSION,'3.2','<')   ) {
      $notice = "<em>* Note: The HS-Membership plugin has control over the <code>Allow new registrations = ".
                esc_html(get_site_option("registration"))."</code> option. For further details, see: ".
                "<code>HS-Member -> General Options -> Blog Creation Restriction</code>.</em>";
      do_action ("hsmember_notices_during_super_admin_options", get_defined_vars ());
      hsmember_notices_add_admin_notice ($notice,'ms-options.php');
    }
    do_action ("hsmember_notices_after_super_admin_options", get_defined_vars ());
    return;
  } // end of hsmember_notices_super_admin_options
}

/**************************************************************************************************/
/* Function to add admin notices to be displayed                                                  */
/*  INPUT: $pv_message - The text of the notice to display.                                       */
/*         $pv_page    - Filename of the page to display the notice for.                          */
/*                       default=FALSE - Display on all admin pages.                              */
/*         $pv_error   - TRUE: Display as an error.                                               */
/*                       default=FALSE: Display as a message.                                     */
/**************************************************************************************** 0.9.0 ***/
if (!function_exists ("hsmember_notices_add_admin_notice"))	{
  function hsmember_notices_add_admin_notice ($pv_message = FALSE,$pv_page = FALSE, $pv_error = FALSE) {
		do_action ("hsmember_notices_before_add_admin_notice", get_defined_vars ());
    if ($pv_message && is_string($pv_message))	{
      $lv_notice_array['message'] = $pv_message;
      $lv_notice_array['error']   = $pv_error;
      if ($GLOBALS["_HSMEMBER_"]["n"][$pv_page]) {
        array_push($GLOBALS["_HSMEMBER_"]["n"][$pv_page],$lv_notice_array);
      }
      else {
        $GLOBALS["_HSMEMBER_"]["n"][$pv_page] = array($lv_notice_array);
      }
		}
		do_action ("hsmember_notices_after_add_admin_notice", get_defined_vars ());
  } // end of function hsmember_notices_add_admin_notice()
}

/**************************************************************************************************/
/* Function to display the admin notices for the current page                                     */
/*  Attach to: add_action("admin_notices",...);                                                   */
/**************************************************************************************** 0.9.0 ***/
if (!function_exists ("hsmember_notices_show_admin_notices")) {
  function hsmember_notices_show_admin_notices () {
    global $pagenow;
    do_action("hsmember_notices_before_show_admin_notices", get_defined_vars ());
    if (is_array($GLOBALS["_HSMEMBER_"]["n"][0])) {
      foreach ($GLOBALS["_HSMEMBER_"]["n"][0] as $lv_notice)
        if ($lv_notice['error'])
          echo '<div class="error fade"><p>'.$lv_notice['message'].'</p></div>';
        else
          echo '<div class="updated fade"><p>'.$lv_notice['message'].'</p></div>';
    }
    if (is_array($GLOBALS["_HSMEMBER_"]["n"][$pagenow]))
      foreach ($GLOBALS["_HSMEMBER_"]["n"][$pagenow] as $lv_notice)
        if ($lv_notice['error'])
          echo '<div class="error fade"><p>'.$lv_notice['message'].'</p></div>';
        else
          echo '<div class="updated fade"><p>'.$lv_notice['message'].'</p></div>';
  } // end of function hsmember_notices_show_admin_notices()
}
?>
