<?php
/*  
Copyright:  2010 Haden Software <http://haden.cc/>

Released under the terms of the GNU General Public License.
You should have received a copy of the GNU General Public License,
along with this software. In the main directory, see: /licensing/
If not, see: <http://www.gnu.org/licenses/>.
*/

/**************************************************************************************************/ 
/* WARNING: This is a system configuration file, please DO NOT EDIT this file directly!           */
/*      ... Instead, use the plugin options panel in WordPress to override these settings.       */
/**************************************************************************************************/

/**************************************************************************************************/
/* Direct access denial.                                                                          */
/**************************************************************************************** 0.9.0 ***/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
	exit ("Do not access this file directly.");

/**************************************************************************************************/
/* Function to create and update the options array, which will be merged with the user options.   */
/**************************************************************************************** 0.9.0 ***/
function hsmember_configure_option_defaults($options = FALSE) {
  $def = apply_filters("hsmember_default_options",array("options_version" => "1.0",
                                                        "login_required_page" => "",
                                                        "blog_create_access" => 0));
  /* Merge options.  User options will overwrite the default values as applicable */
  $GLOBALS["_HSMEMBER_"]["o"] = array_merge($def,(($options !== false) ? 
                                                  (array)$options : 
                                                  (array)get_option("hsmember_options")));
  /* Validate each option, possibly reverting back to the default value if invalid.
     Also check if options were passed in on some of these, in case empty values are to be allowed. */
  foreach ($GLOBALS["_HSMEMBER_"]["o"] as $key => &$value) {
    if (!is_array ($value))
      $value = trim (stripslashes ($value));
    else /* A string, or an array of strings. */
      foreach ($value as $k => $v)
        $value[$k] = trim (stripslashes ($v));
    if ($key === "options_version" && (!is_string ($value) || !is_numeric ($value)))
      $value = $default_options[$key];
    else if ($key === "login_required_page" && (!is_string ($value) || !is_numeric ($value)))
      $value = $default_options[$key];
    else if ($key === "blog_create_access" && (!is_numeric ($value) || $value<0 || $value>4))
      $value = $default_options[$key];
  }
  return apply_filters_ref_array("hsmember_options",array(&$GLOBALS["_HSMEMBER_"]["o"]));
} // end of hsmember_configure_option_defaults()

// Configure & validate all of the plugin options; and set their defaults.
call_user_func ("hsmember_configure_option_defaults");
?>